# Copyright (c) 2000-2010, JPackage Projectc
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/picketlink/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag %{nil}
%define namedversion %{version}%{reltag}
%define base_name picketlink
%define mockitoversion 1.8.0
%define htmlparserversion 1.6
%define xmlunitversion 1.1
# JBPAPP-7010 if openid4java is needed use 0.9.6

Name:           picketlink-federation
Epoch:          0
Version:        2.0.2
Release:        1.1%{?dist}
Summary:        Development files for %{name}

Group:          Development/Tools
License:        LGPL
URL:            http://www.jboss.org/picketlink/docs.html

%define groupId org.picketlink

# svn export http://anonsvn.jboss.org/repos/picketlink/product/tags/2.0.2/ picketlink-federation-2.0.2
# Exported revision 1309.
# tar czf picketlink-federation-2.0.2-src.tar.gz picketlink-federation-2.0.2
Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-jpp-depmap.xml

# FIXME: Remove these and all binary jars
#mockito-all-1.8.0.jar
Source2:        https://repository.jboss.org/nexus/content/groups/public//org/mockito/mockito-all/1.8.0/mockito-all-1.8.0.jar
#xmlunit-1.1.jar
Source4:        https://repository.jboss.org/nexus/content/groups/public//xmlunit/xmlunit/1.1/xmlunit-1.1.jar
#htmlparser-1.6.jar
Source5:        https://repository.jboss.org/nexus/content/groups/public/org/htmlparser/htmlparser/1.6/htmlparser-1.6.jar
#Patch1:         %{name}-javadoc-memory.patch
Patch1:          %{name}-apiviz.patch
Patch2:          %{base_name}-core-pom.patch

BuildArch:      noarch

BuildRequires:  jpackage-utils

BuildRequires:  java-devel >= 0:1.5.0

BuildRequires:  maven2
BuildRequires:  maven2-plugin-war
BuildRequires:  mojo-maven2-plugin-jaxb2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-provider-junit4
#sun-jaxws:jaxws-api:jar:2.1.1
BuildRequires:  glassfish-jaxws
#javax.xml.soap:saaj-api:jar:1.3
BuildRequires:  sun-saaj-1.3-api
#apache-logging:commons-logging-api:jar:1.0.3
BuildRequires:  jakarta-commons-logging
BuildRequires:  jboss-bootstrap
BuildRequires:  jboss-deployers
#org.jboss.javaee:jboss-ejb-api:jar:3.0.0.GA
BuildRequires:  jboss-ejb-3.0-api
# org.jboss.spec.javax.security.jacc:jboss-jacc-api_1.4_spec:jar:1.0.0.Final
BuildRequires:  jboss-jacc-1.1-api
BuildRequires:  jboss-parent
BuildRequires:  jboss-test
BuildRequires:  jboss-security-xacml
#org.jboss.ws.native:jbossws-native-jaxrpc:jar:3.0.4.GA
BuildRequires:  jbossws
BuildRequires:  jbossws-parent
#apache-xalan:xalan:2.7.1.patch01-brew , ... serializer.jar
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-security
#org.apache.tomcat:annotations-api:jar:6.0.18
BuildRequires:  tomcat6-lib
#/builddir/build/BUILD/picketlink-federation-1.0.3-src/picketlink-web/src/main/java/org/picketlink/identity/federation/web/servlets/IDPServlet.java:[191,84] cannot find symbol:symbol  : method getContextPath()
BuildRequires:  tomcat6-servlet-2.5-api
BuildRequires:  glassfish-jaxb
#org.jboss.aop:jboss-aop:jar:2.1.6.GA
BuildRequires:  jboss-aop2
BuildRequires:  jetty6
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  nekohtml
BuildRequires:  glassfish-jsf
BuildRequires:  glassfish-jaf
BuildRequires:  jboss-javaee
BuildRequires:  jbossweb-lib
BuildRequires:  codehaus-stax-api
BuildRequires:  hibernate3-ejb-persistence-3.0-api
#BuildRequires:  jboss-seam2
BuildRequires:   zip

## xml/xstl handling
BuildRequires:  dom4j
BuildRequires:  jaxen
BuildRequires:  log4j

Requires:       jpackage-utils
Requires:       jbossws-common
Requires:       jboss-common-logging-spi
Requires:       log4j
Requires:       xml-security
Requires:       jakarta-commons-logging
Requires:       jboss-security-xacml
Requires:       jboss-security-spi
Requires:       jbossweb-lib
Requires:       jbosssx2
Requires:       hibernate3-ejb-persistence-3.0-api
Requires:       jboss-jacc-1.1-api

Requires(post):       jpackage-utils
Requires(postun):     jpackage-utils

Requires:       java

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

#Requires:       
# JAXB V2 Library
# STAX API Library (a dependency for JAXB2)
# Activation API Library (a dependency for JAXB2)

%description

%package javadoc
Summary:        Javadocs for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%package sources
Summary:        Sources for %{name}
Group:          Development

%description sources
This package contains the sources for %{name}.

%package zip
Summary:        zip for %{name}
Group:          Development/Documentation

%description zip
This package contains the zip for %{name}.

%package webapp-idp
Summary:        Idp web application for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description webapp-idp
This package contains the identity provider web application for %{name}.

%package webapp-pdp
Summary:        Pdp web application for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description webapp-pdp
This package contains the policy decision point web application for %{name}.

%package webapp-sts
Summary:        Sts web application for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description webapp-sts
This package contains the security token service of WS-Trust web application for %{name}.

%package webapps-zip
Summary:        zip web applications for %{name}
Group:          Development/Documentation

%description webapps-zip
This package contains the zipped web application samples for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q

%patch1 -p1
%patch2 -p1

# FIXME
mkdir -p m2_repo/repository/org/mockito/mockito-all/%{mockitoversion}/
cp -p %{SOURCE2} m2_repo/repository/org/mockito/mockito-all/%{mockitoversion}/mockito-all-%{mockitoversion}.jar

mkdir -p m2_repo/repository/xmlunit/xmlunit/%{xmlunitversion}/
cp -p %{SOURCE4} m2_repo/repository/xmlunit/xmlunit/%{xmlunitversion}/xmlunit-%{xmlunitversion}.jar

mkdir -p m2_repo/repository/org/htmlparser/htmlparser/%{htmlparserversion}/
cp -p %{SOURCE5} m2_repo/repository/org/htmlparser/htmlparser/%{htmlparserversion}/htmlparser-%{htmlparserversion}.jar

mkdir -p m2_repo/repository/javax/security/jaas/1.0.01/
ln -sf  %{java_home}/jre/lib/rt.jar m2_repo/repository/javax/security/jaas/1.0.01/jaas-1.0.01.jar

%build
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL

%{_bindir}/mvn-jpp -e \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    -Dmaven2.jpp.depmap.file=%{SOURCE1} \
    -Dmaven.test.skip=true \
    install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT
echo $(pwd)

#jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name}

#Jars to include:
#assembly/target,picketlink-bindings/target,picketlink-bindings-jboss/target,picketlink-seam/target

cp -p %{base_name}-core/target/%{base_name}-core-%{namedversion}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p %{base_name}-core/target/%{base_name}-core-%{namedversion}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}

# javadoc

# target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
rm -rf target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}/%{base_name}-core-%{namedversion}
cp -pr %{base_name}-core/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}/%{base_name}-core-%{namedversion}
rm -rf %{base_name}-core/target/site/apidocs

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
for artifactId in \
    %{base_name}-fed-pom \
    %{base_name}-fed-parent \
    %{base_name}-core \
    %{base_name}-sts \
    %{base_name}-federation-webapps \
    idp \
    pdp \
    ; do
install -pm 644 \
  m2_repo/repository/org/picketlink/product/${artifactId}/%{namedversion}/${artifactId}-%{namedversion}.pom \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{groupId}-${artifactId}.pom

%add_to_maven_depmap %{groupId} ${artifactId} %{namedversion} JPP/%{groupId} ${artifactId}
done

#webapps
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}

mkdir -p tmp/%{name}-webapps
pushd tmp/%{name}-webapps
mkdir idp.war ; cd idp.war
jar xf ../../../picketlink-webapps/idp/target/idp.war
cd .. ; mkdir pdp.war ; cd pdp.war
jar xf ../../../picketlink-webapps/pdp/target/pdp.war
cd .. ; mkdir picketlink-sts.war ; cd picketlink-sts.war
jar xf ../../../picketlink-webapps/picketlink-sts/target/picketlink-sts.war
popd
cp -pr tmp/%{name}-webapps $RPM_BUILD_ROOT%{_datadir}/%{name}

#for examples zip
pushd tmp
mkdir -p $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev
zip -r $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/%{name}-webapps-assembly-%{version}.zip \
%{name}-webapps
popd
rm -fr tmp

#for the zip
mkdir -p $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev
pushd $RPM_BUILD_ROOT%{_javadir}
zip -r $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/%{name}-%{namedversion}.zip %{name} \
  -x %{name}/*-sources.jar -x %{name}/*-webapps-assembly-*.zip
chmod 644 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/%{name}-%{namedversion}.zip
popd

#link jars
# Unversioned symlinks to JARs
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{namedversion}*.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
cp -p %{base_name}-core/target/%{base_name}-core-%{namedversion}.jar \
  %{buildroot}%{repodirlib}/%{base_name}-core.jar
cp -p %{base_name}-core/target/%{base_name}-core-%{namedversion}-sources.jar \
  %{buildroot}%{repodirlib}/%{base_name}-core-sources.jar
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{groupId}-picketlink-core.pom \
  %{buildroot}%{repodirlib}/%{base_name}-core.pom
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
if [ "$1" = "1" ]; then
if [ -d /var/lib/jbossas/server ] ; then
   ln -sf %{_javadir}/%{name}/%{base_name}-core.jar /var/lib/jbossas/common/lib/
elif [ -d /var/lib/jbossas-web/server ] ; then
   ln -sf %{_javadir}/%{name}/%{base_name}-core.jar /var/lib/jbossas-web/common/lib/
fi
fi

%postun
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
if [ -d /var/lib/jbossas/server ] ; then
   rm -f /var/lib/jbossas/common/lib/%{base_name}-core.jar
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -f /var/lib/jbossas-web/common/lib/%{base_name}-core.jar
fi
fi

%post webapp-idp
if [ "$1" = "1" ]; then
#create symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   for profile in default web production standard all; do
      ln -sf %{_datadir}/%{name}/%{name}-webapps/idp.war /var/lib/jbossas/server/$profile/deploy
   done
elif [ -d /var/lib/jbossas-web/server ] ; then
   for profile in default production; do
      ln -sf %{_datadir}/%{name}/%{name}-webapps/idp.war /var/lib/jbossas-web/server/$profile/deploy
   done
fi
fi

%preun webapp-idp
if [ "$1" = "0" ]; then
#remove symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   rm -fr /var/lib/jbossas/server/{default,web,production,standard,all}/deploy/idp.war
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -fr /var/lib/jbossas-web/server/{default,production}/deploy/idp.war
fi
fi

%post webapp-pdp
if [ "$1" = "1" ]; then
#create symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   for profile in default web production standard all; do
      ln -sf %{_datadir}/%{name}/%{name}-webapps/pdp.war /var/lib/jbossas/server/$profile/deploy
   done
elif [ -d /var/lib/jbossas-web/server ] ; then
   for profile in default production; do
      ln -sf %{_datadir}/%{name}/%{name}-webapps/pdp.war /var/lib/jbossas-web/server/$profile/deploy
   done
fi
fi

%preun webapp-pdp
if [ "$1" = "0" ]; then
#remove symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   rm -fr /var/lib/jbossas/server/{default,web,production,standard,all}/deploy/pdp.war
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -fr /var/lib/jbossas-web/server/{default,production}/deploy/pdp.war
fi
fi

%post webapp-sts
if [ "$1" = "1" ]; then
#create symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   for profile in default web production standard all; do
      ln -sf %{_datadir}/%{name}/%{name}-webapps/picketlink-sts.war /var/lib/jbossas/server/$profile/deploy
   done
elif [ -d /var/lib/jbossas-web/server ] ; then
   for profile in default production; do
      ln -sf %{_datadir}/%{name}/%{name}-webapps/picketlink-sts.war /var/lib/jbossas-web/server/$profile/deploy
   done
fi
fi

%preun webapp-sts
if [ "$1" = "0" ]; then
#remove symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   rm -fr /var/lib/jbossas/server/{default,web,production,standard,all}/deploy/picketlink-sts.war
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -fr /var/lib/jbossas-web/server/{default,production}/deploy/picketlink-sts.war
fi
fi

%files
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{base_name}-*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}

%exclude %{_javadir}/%{name}/*-sources.jar

%files javadoc
%defattr(-,root,root,-)
%%doc %{_javadocdir}/%{name}-%{version}

%files sources
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*-sources.jar

%files zip
%defattr(-,root,root,-)
%{_javadir}*/jbossas-fordev/%{name}-%{namedversion}.zip

%files webapp-idp
%defattr(-,root,root,-)
%{_datadir}/%{name}/%{name}-webapps/idp.war

%files webapp-pdp
%defattr(-,root,root,-)
%{_datadir}/%{name}/%{name}-webapps/pdp.war

%files webapp-sts
%defattr(-,root,root,-)
%{_datadir}/%{name}/%{name}-webapps/picketlink-sts.war

%files webapps-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/%{name}-webapps-assembly-*.zip

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Oct 19 2011 Fernando Nasser <fnasser@redhat.com> - 0:2.0.2-1
- Upgrade to 2.0.2

* Wed Oct 12 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.0.1-2
- Split webapps into individual -idp, -dpd and -sts subpackages
- Add proper Requires according to pom
- Create symlinks for jar and wars

* Wed Sep 28 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-1
- Upgrade to 2.0.1

* Mon Sep 06 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.0-4.1
- Remove binaries for openid4java, openxri, seam
- Add BR xml-commons-jaxp-1.3-apis

* Mon Aug 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.0-3
- Remove binaries for jaas, jacc and jvmti

* Mon Aug 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.0-2
- Add repolib

* Wed Aug 17 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.0-1.1
- Upgrade to 2.0.0
- Add BR jboss-test, jboss-jacc-1.1-api, jboss-deployers, jboss-bootstrap

* Fri Feb 18 2011 Permaine Cheung <pcheung@redhat.com> 0:1.0.3-12.2
- JB-EAP-5-RHEL-6 build

* Thu Feb 17 2011 Permaine Cheung <pcheung@redhat.com> 0:1.0.3-12.1
- Put picketlink-fed-webapps-assembly example zip in the same location 
  as other zip

* Wed Jul 28 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-11
- Included picketlink-fed-webapps-assembly example zip

* Wed Jun 23 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.3-10
- Merge from RHEL4
- Add BR: zip

* Fri Jun 18 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.3-7.1
- Generate %{name}-javadoc-memory.patch to increase memory available during javadoc generation

* Mon Jun 07 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-7
- Regenerate picketlink-federation-dependency.patch

* Mon Jun 07 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-6
- Update sources to 1.0.3.final

* Thu Jun 03 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-5
- Update reltag to CR4

* Thu Jun 03 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-4
- Add version number in tarball directory structure

* Thu Jun 03 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-3
- Fix tarball directory structure

* Thu Jun 03 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-2
- Update sources to include missing binaries

* Wed Jun 02 2010 Brian Shim <bshim@redhat.com> 0:1.0.3-1
- First release
